<form (ngSubmit)="onSubmit()"
      [formGroup]="form"
      [solidifyFocusFirstElement]="true"
>

  <solidify-detail-presentation [centerTemplate]="centerTemplate"
                                [iconName]="iconNameEnum.jobs"
                                [rightTemplate]="rightTemplate"
  ></solidify-detail-presentation>

  <ng-template #centerTemplate>

    <mat-form-field *ngIf="getFormControl(formDefinition.name) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.nameLabel | translate}}</mat-label>
      <input [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.jobType) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.jobType | translate}}</mat-label>
      <mat-select [formControl]="fd"
                  [required]="formValidationHelper.hasRequiredField(fd)"
                  [solidifyValidation]="errors"
      >
        <mat-option *ngFor="let jobType of listJobType"
                    [value]="jobType.key"
                    solidifyTooltipOnEllipsis
        >
          {{jobType.value | translate}}
        </mat-option>
      </mat-select>
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.jobRecurrence) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.jobRecurrence | translate}}</mat-label>
      <mat-select [formControl]="fd"
                  [required]="formValidationHelper.hasRequiredField(fd)"
                  [solidifyValidation]="errors"
      >
        <mat-option *ngFor="let jobRecurrence of listJobRecurrence"
                    [value]="jobRecurrence.key"
                    solidifyTooltipOnEllipsis
        >
          {{jobRecurrence.value | translate}}
        </mat-option>
      </mat-select>

      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <!-- SCHEDULING -->
    <ng-container *ngIf="getFormControl(formDefinition.jobRecurrence)?.value &&
          getFormControl(formDefinition.jobRecurrence)?.value !== jobRecurrenceEnum.ONCE"
    >
      <!-- DAY OF WEEK -->
      <ng-container *ngIf="getFormControl(formDefinition.jobRecurrence)?.value === jobRecurrenceEnum.WEEKLY">
        <mat-form-field *ngIf="getFormControl(formDefinition.weekDay) as fd"
                        [appearance]="appearanceInputMaterial"
                        [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                        [floatLabel]="'always'"
                        solidifyTooltipOnEllipsis
        >
          <mat-label>{{'preservation.job.form.scheduling.weekDay' | translate}}</mat-label>
          <mat-select [formControl]="fd"
                      [required]="formValidationHelper.hasRequiredField(fd)"
                      [solidifyValidation]="errors"
          >
            <mat-option *ngFor="let day of listWeekDay"
                        [value]="day.key"
                        solidifyTooltipOnEllipsis
            >
              {{day.value | translate}}
            </mat-option>
          </mat-select>
          <mat-error #errors
                     solidifyTooltipOnEllipsis
          ></mat-error>
        </mat-form-field>
      </ng-container>

      <!-- MONTH -->
      <ng-container
          *ngIf="getFormControl(formDefinition.jobRecurrence)?.value === jobRecurrenceEnum.YEARLY"
      >
        <mat-form-field *ngIf="getFormControl(formDefinition.month) as fd"
                        [appearance]="appearanceInputMaterial"
                        [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                        [floatLabel]="'always'"
                        solidifyTooltipOnEllipsis
        >
          <mat-label>{{'preservation.job.form.scheduling.month' | translate}}</mat-label>
          <mat-select [formControl]="fd"
                      [required]="formValidationHelper.hasRequiredField(fd)"
                      [solidifyValidation]="errors"
          >
            <mat-option *ngFor="let month of listMonth"
                        [value]="month.key"
                        solidifyTooltipOnEllipsis
            >
              {{month.value | translate}}
            </mat-option>
          </mat-select>
          <mat-error #errors
                     solidifyTooltipOnEllipsis
          ></mat-error>
        </mat-form-field>
      </ng-container>

      <!-- DAY OF MONTH -->
      <ng-container
          *ngIf="getFormControl(formDefinition.jobRecurrence)?.value === jobRecurrenceEnum.MONTHLY
      || getFormControl(formDefinition.jobRecurrence)?.value === jobRecurrenceEnum.YEARLY"
      >
        <mat-form-field *ngIf="getFormControl(formDefinition.monthDay) as fd"
                        [appearance]="appearanceInputMaterial"
                        [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                        [floatLabel]="'always'"
                        solidifyTooltipOnEllipsis
        >
          <mat-label>{{'preservation.job.form.scheduling.monthDay' | translate}}</mat-label>
          <input [formControl]="fd"
                 [required]="formValidationHelper.hasRequiredField(fd)"
                 [solidifyValidation]="errors"
                 matInput
                 type="number"
          >
          <mat-error #errors
                     solidifyTooltipOnEllipsis
          ></mat-error>
        </mat-form-field>
      </ng-container>

      <!-- HOUR -->
      <ng-container>
        <ng-container *ngIf="!editValue; else editHour">
          <mat-form-field *ngIf="getFormControl(formDefinition.hour) as fd"
                          [appearance]="appearanceInputMaterial"
                          [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                          [floatLabel]="'always'"
                          solidifyTooltipOnEllipsis
          >
            <mat-label>{{'preservation.job.form.scheduling.hour' | translate}}</mat-label>
            <input (focus)="focusFieldEditable()"
                   [formControl]="fd"
                   [required]="formValidationHelper.hasRequiredField(fd)"
                   [solidifyValidation]="errors"
                   [value]="(fd.value | isNullOrUndefined) || fd.value === '' ? '' : (fd.value > 9 ? fd.value + ':00' : '0' + fd.value + ':00')"
                   matInput
            >
            <mat-error #errors
                       solidifyTooltipOnEllipsis
            ></mat-error>
          </mat-form-field>
        </ng-container>
        <ng-template #editHour>
          <mat-form-field *ngIf="getFormControl(formDefinition.hour) as fd"
                          [appearance]="appearanceInputMaterial"
                          [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                          solidifyTooltipOnEllipsis
          >
            <mat-label>{{'preservation.job.form.scheduling.hour' | translate}}</mat-label>
            <input #hourFormatEditable
                   (blur)="checkHour()"
                   [formControl]="fd"
                   [required]="formValidationHelper.hasRequiredField(fd)"
                   [solidifyValidation]="errors"
                   [value]="fd.value"
                   matInput
                   max="23"
                   min="0"
                   type="number"
            >
            <mat-error #errors
                       solidifyTooltipOnEllipsis
            ></mat-error>
          </mat-form-field>
        </ng-template>
      </ng-container>
    </ng-container>

    <!-- Job Parameters-->
    <mat-form-field *ngIf="getFormControl(formDefinition.parameters) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{'preservation.job.form.jobParameters' | translate}}</mat-label>
      <input [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

  </ng-template>

  <ng-template #rightTemplate>

    <mat-checkbox [formControlName]="formDefinition.enable"
                  color="primary"
                  class="is-active"
    >{{labelTranslateEnum.enabled | translate}}
    </mat-checkbox>

    <mat-form-field *ngIf="getFormControl(formDefinition.maxItems) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{'preservation.job.form.maxItems' | translate}}</mat-label>
      <input [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             matInput
             min="0"
             type="number"
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

  </ng-template>

  <dlcm-shared-additional-information-panel-container *ngIf="model | isNotNullNorUndefined"
                                                      [resource]="model"
  >
  </dlcm-shared-additional-information-panel-container>
</form>
